package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingImporteDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingImporte;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.service.GP_PricingImporteService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingImporteService")
public class GP_PricingImporteServiceImpl implements GP_PricingImporteService {

    @Autowired
    private GP_PricingImporteDAO pricingImporteDAO;

    public List<GP_PricingImporte> obtenerTodos() {
        return pricingImporteDAO.obtenerTodos();
    }

    public GP_PricingImporte obtenerID(Integer id) {
        return pricingImporteDAO.obtenerID(id);
    }

    @Transactional
    public GP_PricingImporte suscribir(GP_PricingImporte entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingImporteDAO.suscribir(entidad);
    }

    @Transactional
    public GP_PricingImporte actualizacion(GP_PricingImporte entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingImporteDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(GP_PricingImporte entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.EXCLUIDO);

        pricingImporteDAO.actualizacion(entidad);
    }

    public List<GP_PricingImporte> buscarMoneda(GP_PricingImporte pricingImporte, Moneda moneda) {
        return pricingImporteDAO.buscarMoneda(pricingImporte, moneda);
    }

	@Override
	public List<GP_PricingImporte> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingImporteDAO.obtenerTodoPorPricing(pricing);
	}
}
